package loopbounds;

/** This example shows how branch-splitting can be used to deal with
  * conditionals in the loop body */
public class BranchSplitting {
	public void simple (int i) {
		while (i > 0) {
			if (i > 100)
				i -= 10;
			else
				i -= 1;
		}
	}

	public void nested (int i) {
		while (i > 0) {
			if (i > 100) {
				if (i > 200)
					i -= 10;
				else
					i -= 20;
			} else {
				i -= 1;
			}
		}
	}

	public void switching (int i) {
		while (i > 0) {
			switch (i) {
				case 10: i -= 1;
				case 30: i -= 3;
				default: i -= 10;
			}
		}
	} 

	public void evenOdd (int i) {

		while (i > 0) {
			if (i % 2 == 0)
				i -= 3;
			else
				i -= 1;
		}
	}

	/* Works only when not applying branch-splitting */
	public void codeAfterBranch (int start, int end) {

		while (start<end) {
			if (start == 3)
				return;
			start++;
		}
	}

	public void appending (int start, int end) {

		while (start<end) {
			if (start == 3)
				start++;	
			if (start > 40)
				start += 4;
			else
				start += 2;
		}
	}
}
